//
// Created by jtwite on 28.03.20.
//
#include <sys/mman.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <string.h>
#include "fileFeatures.h"

int main(int argc, char *argv[])
{
    struct timeval stop, start;
    gettimeofday(&start, NULL);

    printf("file input: %s\n", argv[1]); // argv[1] = input file path
    printf("file output: %s\n", argv[2]); // argv[2] = output file path

    //open the fileInput
    int fileInput = open(argv[1], O_RDONLY);
    if (fileInput <= 0)
        exit(1);

    // get the fileInput size, map it in the virtual &dress space and close fileInput directory
    struct stat sb;
    fstat(fileInput, &sb);
    char *file_in_memory = mmap(NULL, sb.st_size, PROT_READ, MAP_PRIVATE, fileInput, 0);
    close(fileInput);
    
    FILE *fileOutput = fopen(argv[2], "w"); // Create the file output
    if(fileOutput == NULL)
        exit(-2);
    
    //go through the mapped file, read numbers and write them in fileOutput
    factorize(file_in_memory, fileOutput);

    // unmap fileInput and close fileOutput
    munmap(file_in_memory, sb.st_size);
    fclose(fileOutput);

    // print out the computation performance
    gettimeofday(&stop, NULL);
    printf("SUCCES.\ntook %lu µs\n", (stop.tv_sec - start.tv_sec) * 1000000 + stop.tv_usec - start.tv_usec);

    return 0;
}
